package x64

// Call places the return address on the top of the stack and continues
// program flow at the new address. The address is relative to the next instruction.
func Call(code []byte, address uint32) []byte {
	return append(
		code,
		0xe8,
		byte(address),
		byte(address>>8),
		byte(address>>16),
		byte(address>>24),
	)
}
