package asm

import "git.akyoto.dev/cli/q/src/build/cpu"

// MoveRegisterNumber moves a number into the given register.
func (a *Assembler) MoveRegisterNumber(reg cpu.Register, number uint64) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: MOVE,
		Data: &RegisterNumber{
			Register: reg,
			Number:   number,
		},
	})
}

// Label adds a label at the current position.
func (a *Assembler) Label(name string) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: LABEL,
		Data: &Label{
			Name: name,
		},
	})
}

// Call calls a function whose position is identified by a label.
func (a *Assembler) Call(name string) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: CALL,
		Data: &Label{
			Name: name,
		},
	})
}

// Return returns back to the caller.
func (a *Assembler) Return() {
	a.Instructions = append(a.Instructions, Instruction{Mnemonic: RETURN})
}

// Syscall executes a kernel function.
func (a *Assembler) Syscall() {
	a.Instructions = append(a.Instructions, Instruction{Mnemonic: SYSCALL})
}
